/* Project SWORD
   V2.0

   SubSystem : Little usefull graphical objects
   File      : Include/Gadgets/TitleBar.H
   Author    : Eric NICOLAS
   Overview  : TTitleBar object
   UpDate    : May 22, 1995

** Copyright (C) 1993,1995 The SWORD Group
**
** This file is distributed under the terms listed in the document
** "copying.en". A copy of "copying.en" should accompany this file.
** if not, a copy should be available from where this file was obtained.
** This file may not be distributed without a verbatim copy of "copying.en".
**
** This file is distributed WITHOUT ANY WARRANTY; without even the implied
** warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

#ifndef _GADGETS_TITLEBAR_H_
#define _GADGETS_TITLEBAR_H_

extern short RegTTitleBar;
extern char *IdentTTitleBar;

struct TTitleBar : TZone
{ // Datas
  char *Title;
  // Constructors
          TTitleBar();
          TTitleBar(int X, int Y, int L, int H, char *_Title);
          TTitleBar(TRect& R, char *_Title);
          void     Init(char *_Title=NULL);
  virtual ~TTitleBar(void);
          void     Done(void);
  // Events
          boolean  HandleCommand(long Command, char , short , long , void *);
          boolean  MouseLDown(TPoint& Where, int Buttons);
  // Graphics
  virtual void     Draw(TRect& Clip);
  virtual void     ShrinkInside(TRect& InsideFather);
  // Objects streams
  virtual TAtom*   Duplicate(void);
  // Linked lists
          TWindow *Father(void);
};

// Inline functions

inline TAtom* TTitleBar::Duplicate(void)
{ return new TTitleBar();
}

inline TWindow* TTitleBar::Father(void)
{ return (TWindow*)(TZone::Father());
}

#endif // _GADGETS_TITLEBAR_H_
