/* Project SWORD
   V2.0

   SubSystem : Mathematical toolbox
   File      : Include/ToolBox/Math/MError.H
   Author    : Eric NICOLAS
   Overview  : Errors in math toolbox
   UpDate    : May 18, 1995
   Error Msg : 200 -> 299

** Copyright (C) 1993,1995 The SWORD Group
**
** This file is distributed under the terms listed in the document
** "copying.en". A copy of "copying.en" should accompany this file.
** if not, a copy should be available from where this file was obtained.
** This file may not be distributed without a verbatim copy of "copying.en".
**
** This file is distributed WITHOUT ANY WARRANTY; without even the implied
** warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

#ifndef _TOOLBOX_MATH_MERROR_H_
#define _TOOLBOX_MATH_MERROR_H_

#define MError_Base                 200
#define MError_End                  299

#define MError_Vector_OutOfSize     200
#define MError_Vector_MixingSizes   201

#define MError_Matrix_OutOfSize     220
#define MError_Matrix_MixingSizes   221
#define MError_Matrix_VectorSize    222
#define MError_Matrix_Rectangular   223
#define MError_Matrix_Singularity   224

#define MError_Poly_NoFactorisation 240

extern int MathError;

char *GetMathErrorMessage(int Error);

#endif // _TOOLBOX_MATH_MERROR_H_
