/* Project SWORD
   V2.0

   SubSystem : Description of the aspects of graphical drawings
   File      : LibSrc/Drawings/Drawings.CC
   Author    : Eric NICOLAS
   Overview  : Init / Done of the Drawings module, some drawings
   UpDate    : Dec 19, 1994

** Copyright (C) 1993,1995 The SWORD Group
**
** This file is distributed under the terms listed in the document
** "copying.en". A copy of "copying.en" should accompany this file.
** if not, a copy should be available from where this file was obtained.
** This file may not be distributed without a verbatim copy of "copying.en".
**
** This file is distributed WITHOUT ANY WARRANTY; without even the implied
** warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

#include "Common/Common.H"
#include "Mecanism/Mecanism.H"
#include "Graphics/Graphics.H"
#include "Drawings/Drawings.H"

// --- Global variables

TIcone *ICO_World;

// ----- The Drawings

#include "Drawings/World.INC"
#include "Drawings/OK.INC"
#include "Drawings/Cancel.INC"
#include "Drawings/Check.INC"
#include "Drawings/Radio.INC"
#include "Drawings/Frame.INC"

// --- Functions

void InitDrawings(void)
{ ICO_World=new TIcone(32,32,desICO_World);
  ICO_World->Options &= ~MAP_Delete;
  Debug("  DRAWINGS...  Initialized.\n");
}

void DoneDrawings(void)
{ delete ICO_World;
}
