/* Project SWORD
   V2.0

   SubSystem : Little usefull graphical objects
   File      : LibSrc/Gadgets/StdWin.CC
   Author    : Eric NICOLAS
   Overview  : TStdWin object : Standard window
   UpDate    : Oct 05, 1995

** Copyright (C) 1993,1995 The SWORD Group
**
** This file is distributed under the terms listed in the document
** "copying.en". A copy of "copying.en" should accompany this file.
** if not, a copy should be available from where this file was obtained.
** This file may not be distributed without a verbatim copy of "copying.en".
**
** This file is distributed WITHOUT ANY WARRANTY; without even the implied
** warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

#include "Common/Common.H"
#include "Mecanism/Mecanism.H"
#include "Graphics/Graphics.H"
#include "Drawings/Drawings.H"
#include "Gadgets/Gadgets.H"

short RegTStdWindow;
char *IdentTStdWindow = "TStdWindow";

TStdWindow::TStdWindow() : TWindow()
{ Init(FALSE,FALSE);
}

TStdWindow::TStdWindow(int X, int Y, int L, int H, char *_Title, boolean Sizeable) :
   TWindow(X,Y,L,H)
{ Init(TRUE,Sizeable,_Title);
}

TStdWindow::TStdWindow(TRect& R, char *_Title, boolean Sizeable) : TWindow(R)
{ Init(TRUE,Sizeable,_Title);
}

void TStdWindow::Init(boolean CreateElements, boolean Sizeable, char *_Title)
{ Register=RegTStdWindow;
  Ident=IdentTStdWindow;
  if (Sizeable) SetOptions(opSizeable);
  if (CreateElements)
  { Insert(new TWindowFrame(Inside,Sizeable));
    Insert(new TTitleBar(Inside,_Title));
    Insert(new TWindowBack(Inside));
  }
}

TStdWindow::~TStdWindow(void)
{ if (!Destroyed)
  { Done();
    Destroyed=TRUE;
  }
}
