/* Project SWORD
   V2.0

   SubSystem : Image manipulation tools
   File      : LibSrc/ToolBox/Image/ImgFile.CC
   Author    : Cedric JOULAIN
   Overview  : TImageFile Object
   UpDate    : Oct 23, 1995

** Copyright (C) 1993,1995 The SWORD Group
**
** This file is distributed under the terms listed in the document
** "copying.en". A copy of "copying.en" should accompany this file.
** if not, a copy should be available from where this file was obtained.
** This file may not be distributed without a verbatim copy of "copying.en".
**
** This file is distributed WITHOUT ANY WARRANTY; without even the implied
** warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

#include "Common/Common.H"
#include "Mecanism/Mecanism.H"
#include "Graphics/Graphics.H"
#include "ToolBox/Image/ImgJPEG.H"
#include "ToolBox/Image/ImgFile.H"

TImageFile::TImageFile(int W, int H)
{ Height = H;
  Width = W;
  if(W*H)
  {	// Because jpeg library is in C we use malloc and free
	R = (byte *) malloc(W*H);
	G = (byte *) malloc(W*H);
	B = (byte *) malloc(W*H);
  }
  else
  {	R = NULL;
	G = NULL;
	B = NULL;
  }
}

TImageFile::~TImageFile(void)
{ // Because jpeg library is in C we use malloc and free
  if(R)	free(R);
  if(G)	free(G);
  if(B)	free(B);
}

void TImageFile::Load(char *Name)
{ int I;
  char c='\0';
  for(I=0; Name[I]; I++)
	if(Name[I]=='.')
		c = Name[I+1];
  /* if extension != .J** not a JPEG file */
  if((c != 'J')&&(c != 'j'))
	Load_C (Name, &Width, &Height, &R, &G, &B);
  else
	read_JPEG_file (Name, &Width, &Height, &R, &G, &B);
}

void TImageFile::Save(char *Name)
{
}
