/* Project SWORD
   V2.0

   SubSystem : Quite sofisticated tools
   File      : LibSrc/Tools/Phases.CC
   Author    : Eric NICOLAS
   Overview  : Execution phases trace
   UpDate    : Oct 23, 1995

** Copyright (C) 1993,1995 The SWORD Group
**
** This file is distributed under the terms listed in the document
** "copying.en". A copy of "copying.en" should accompany this file.
** if not, a copy should be available from where this file was obtained.
** This file may not be distributed without a verbatim copy of "copying.en".
**
** This file is distributed WITHOUT ANY WARRANTY; without even the implied
** warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

#include "Common/Common.H"
#include "Mecanism/Mecanism.H"
#include "Graphics/Graphics.H"
#include "Drawings/Drawings.H"
#include "Gadgets/Gadgets.H"
#include "Tools/WinTools.H"
#include "Tools/Phases.H"

//---------------------------------------------------------------------------
// TPhaseWindow : Fenetre d'affichage des phases

short RegTPhaseWindow;
char *IdentTPhaseWindow = "TPhaseWindow";

TPhaseWindow::TPhaseWindow() : TToolWindow(200,70,"Execution...")
{ Init(NULL);
}

TPhaseWindow::TPhaseWindow(char *Name) :
    TToolWindow(200,90,"Execution...")
{ Init(Name);
}

void TPhaseWindow::Init(char *Name)
{ Register=RegTPhaseWindow;
  Ident=IdentTPhaseWindow;
  Insert(new TStaticText(10, 30, 180, 15, Name));
  Insert(Gauge=new TGauge(10, 60, 180, 20));
}

TPhaseWindow::~TPhaseWindow(void)
{ if (!Destroyed)
  { Done();
    Destroyed=TRUE;
  }
}

//---------------------------------------------------------------------------
// Variables locales

#define MaxPhaseWindows 20

static int           NbPhaseWindows;
static TPhaseWindow *PhaseWindows[MaxPhaseWindows];

//---------------------------------------------------------------------------
// Utilisation des phases d'excution

void BeginPhase(char *Name)
{ if (NbPhaseWindows==MaxPhaseWindows)
  { // Erreur : plus de phases disponibles
  }
  PhaseWindows[NbPhaseWindows]=new TPhaseWindow(Name);
  Desktop->Insert(PhaseWindows[NbPhaseWindows]);
  Desktop->ShowDrawingNow();
  NbPhaseWindows++;
}

void AvancePhase(int Avance)
{ if (NbPhaseWindows==0)
  { // Erreur : aucune phase en cours
  }
  PhaseWindows[NbPhaseWindows-1]->Gauge->SetValue(Avance);
  Desktop->ShowDrawingNow();
}

void EndPhase(void)
{ if (NbPhaseWindows==0)
  { // Erreur : aucune phase en cours
  }
  NbPhaseWindows--;
/* TEMPORAIRE  PhaseWindows[NbPhaseWindows]->UnLink();*/
  delete PhaseWindows[NbPhaseWindows];
  Desktop->ShowDrawingNow();
}

//---------------------------------------------------------------------------
// Init/Done de l'unit PHASE

void InitPhases(void)
{ NbPhaseWindows=0;
}

void DonePhases(void)
{
}
