#ifndef MDMA_H
#define MDMA_H

#include "mtypes.h"

#define READ_DMA                0
#define WRITE_DMA               1
#define INDEF_READ              2
#define INDEF_WRITE             3

#ifdef __cplusplus
extern "C" {
#endif

void *Dma_AllocMem(UWORD size);
void Dma_FreeMem(void *w);
int Dma_Start(int channel,void *pc_ptr,UWORD size,int type);
void Dma_Stop(int channel);
void Dma_Play(void);
UWORD Dma_Todo(int channel);

#ifdef DJGPP
void Dma_MemPutb(UBYTE *buf, UBYTE data, UWORD count);
void Dma_MemPutw(UWORD *buf, UWORD data, UWORD count);
#endif

#ifdef __cplusplus
}
#endif


#endif
