/* Project SWORD
   V2.0

   SubSystem : Demonstration
   Commands  : Group: 10000
   File      : Work/Main.CC
   Author    : Eric NICOLAS
   Overview  : Main program
   UpDate    : Oct 14, 1995

** Copyright (C) 1993,1995 Eric NICOLAS
**
** This file is distributed under the terms listed in the document
** "copying.en". A copy of "copying.en" should accompany this file.
** if not, a copy should be available from where this file was obtained.
** This file may not be distributed without a verbatim copy of "copying.en".
**
** This file is distributed WITHOUT ANY WARRANTY; without even the implied
** warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

#include "Sword.H"

#ifdef __TURBOC__
  #pragma   hdrstop
  #include <alloc.h>
#endif

// ------

#define cmIncValue   10000
#define cmIncGauge   10001
#define cmTestPhases 10002

struct TCompteur : TZone
{ long Value;
  TCompteur(long X, long Y);
  virtual boolean HandleCommand(long Command, char Info08b=0, short Info16b=0, long Info32b=0, void *InfoPtr=NULL);
  virtual void    Draw(TRect& Clip);
};

TCompteur::TCompteur(long X, long Y) : TZone(X,Y,50,20)
{ Value=0;
}

boolean TCompteur::HandleCommand(long Command, char, short, long, void*)
{ switch(Command)
  { case cmIncValue :
      Value++;
      if (Value==100) Value=0;
      Invalidate();
      return TRUE;
  }
  return FALSE;
}

void TCompteur::Draw(TRect& )
{ char Temp[50];
  sprintf(Temp,"%d",Value);
  SetSysColor(GetColor(0));
  FontSystem->BackColor(NoSysColor[GetColor(2)]);
  PutStr(0,0,Temp,FontSystem);
  FontSystem->BackColor(FBack_NOCOLOR);
}

// ------

struct TMyData
{ int Chekcs PACKED;
  int Radios PACKED;
};

TMyData MyData = { 1+2, 4 };

// ------

struct TMonDialog : TDialog
{ TGauge *LaGauge;
  TMonDialog();
  virtual boolean  HandleCommand(long Command, char Info08b=0, short Info16b=0, long Info32b=0, void *InfoPtr=NULL);
};

TMonDialog::TMonDialog() : TDialog(30,30,300,350,"Dialog 1")
{ TGroupBox  *GB;
  Insert(new TStdButton(50,30,50,0,0,boDisabled,"Essai"));
  Insert(new TCancelButton(20,60));
  Insert(new TStdButton(110,60,50,cmIncGauge,0,boNoCase,"&Yes"));
  Insert(new TStdButton(170,60,50,cmIncGauge,0,boNoCase|boImmediate|boRepetition,"&No"));
  Insert(new TOKButton(220,60));
  Insert(new TStaticText(50,90,100,20,"Essai de texte statique"));
  GB=new TGroupBox(10,115,280,85);
  GB->Insert(new TCheckBox(10,10,100, boNoCase, 1, "Check Box &A"));
  GB->Insert(new TCheckBox(10,40,100, boNoCase, 2, "Check Box &B"));
  Insert(GB);
  GB=new TGroupBox(10,200,280,80,"Groupe de Check Boxes");
  GB->Insert(new TRadioBox(10, 20,100, boNoCase, 1, "Radio &C"));
  GB->Insert(new TRadioBox(120,20,100, boNoCase | boDisabled, 2, "Radio &D"));
  GB->Insert(new TRadioBox(10, 60,100, boNoCase, 4, "Radio &E"));
  GB->Insert(new TRadioBox(120,60,100, boNoCase, 8, "Radio &F"));
  Insert(GB);
  Insert(LaGauge=new TGauge(10,290,200,20));
}

boolean TMonDialog::HandleCommand(long Command, char , short , long , void *)
{ if (Command==cmIncGauge)
  { LaGauge->SetValue(LaGauge->CurrentValue+1);
    return TRUE;
  }
  return FALSE;
}

// ------

struct TMonApp : TApp
{ TMonApp(char *argv0);
  virtual boolean MouseRDown(TPoint& Where, int Buttons);
  virtual boolean HandleCommand(long Command, char Info08b=0, short Info16b=0, long Info32b=0, void *InfoPtr=NULL);
};

TMonApp::TMonApp(char *argv0) : TApp(argv0)
{ TDisk *file;
  char   FileName[200];
  // Cration des fentres de test
  TStdWindow *WinTest2=new TStdWindow(10, 200,200,100,"Window 1",TRUE);
  TStdWindow *WinTest3=new TStdWindow(200,100,250,250,"Window 2",TRUE);
  TStdWindow *WinTest4=new TStdWindow(350,250,220,200,"Window 3",TRUE);
  // Remplissage du Dialogue de test
  TDialog    *TheDialog=new TMonDialog();
  // Insert the Dialog into the DeskTop
  Desktop->Insert(TheDialog);
  // Remplissage des autres fentres de test
  WinTest2->Insert(new TCompteur(50,50));
  WinTest2->Insert(new TStdButton(10,30,60,0,0,boNoCase,"Essai &Z"));
  WinTest2->SetColorGroup(ColorBW);
  WinTest3->SetColorGroup(ColorRed);
  WinTest4->SetColorGroup(ColorGreen);
  // Insertion des fentres de test sur le bureau
  Desktop->Insert(WinTest2);
  Desktop->Insert(WinTest3);
  Desktop->Insert(WinTest4);
//  }
  // Cration systeme de MENUs de text
  TMenu *MenuOpen;
  TMenu *MenuFile;
  TMenu *Menu;
  TMenuChoice *MC;
  //
  MenuOpen=new TMenu("Open");
    MC=new TMenuChoice("&Text",0,1);
    MenuOpen->Insert(MC);
    MC=new TMenuChoice("&Image",0,2);
    MenuOpen->Insert(MC);
    MC=new TMenuChoice("&Sound",0,3);
    MenuOpen->Insert(MC);


  MenuFile=new TMenu("File");
    MC=new TMenuChoice("&New",0,cmFileNew);
    MenuFile->Insert(MC);
    MC=new TMenuChoice("&Open",MenuOpen);
    MenuFile->Insert(MC);
    MC=new TMenuChoice("&Save",0,cmFileSave);
    MenuFile->Insert(MC);
    MC=new TMenuChoice("Save &as",0,cmFileSaveAs);
    MenuFile->Insert(MC);

  Menu=new TMenu("Appli Test",opMainMenu);
    MC=new TMenuChoice("&File",MenuFile);
    Menu->Insert(MC);
    MC=new TMenuChoice("&Edition",0,10,sfDisabled);
    Menu->Insert(MC);
    MC=new TMenuChoice("&Test Phases",0,cmTestPhases);
    Menu->Insert(MC);
    MC=new TMenuChoice();
    Menu->Insert(MC);
    MC=new TMenuChoice("&Quit",ScanAltX,cmQuit);
    Menu->Insert(MC);
  Menu->InitChoices();
  Desktop->Insert(Menu);
}

boolean TMonApp::MouseRDown(TPoint& , int )
{ ExitCode=1;
  return TRUE;
}

boolean TMonApp::HandleCommand(long Command, char , short , long , void *)
{ int i,j;
  switch(Command)
  { case cmQuit:
      ExitCode=1;
      return TRUE;
    case cmTestPhases:
      BeginPhase("Test phases No1");
      for(i=0;i<=100;i++)
      { AvancePhase(i);
        Delay(10);
        if (i==40)
        { BeginPhase("Test phases No2");
          for(j=0;j<=100;j+=2)
          { AvancePhase(j);
            Delay(1);
          }
          EndPhase();
        }
      }
      EndPhase();
      return TRUE;
  }
  return FALSE;
}

// ====

int main(char , char *argv[])
{
/*  long t,t_cur=0;
  while(!kbhit())
  { t=GetTime()/100l;
    if (t!=t_cur)
    { printf("%ld\n",t);
      t_cur=t;
    }
  }
  return 0;
*/

#ifdef __TURBOC__
  long MemFree = coreleft();
#endif

  TMonApp *MonApp;

  MonApp=new TMonApp(argv[0]);
  MonApp->EventsLoop(MonApp);
  delete MonApp;

#ifdef __TURBOC__
  MemFree-=coreleft();
  if (!MemFree) printf("!!! ERREUR programmeur : mmoire non libre !!!\n");
#endif

  return 0;
}


/*  sprintf(FileName,"%sEXAMPLE.OSF",SwordPath);
  Debug("Ouverture de : %s\n",FileName);
  file=new TDisk(FileName,stOpen);
  if (file->Error)
  { Debug("ERREUR pour ouvrir le fichier OSF\n");
  }
  else
  {
  TDialog    *WinTest1=(TDialog*)ReadObject(file);
  WinTest1->SetData(&MyData);
  delete file;*/
//  Desktop->Insert(WinTest1);
