.\" $Id: whatis.man,v 2.0 1992/09/13 05:09:30 rosenkra Exp $
.\"
.\" $Log: whatis.man,v $
.\" Revision 2.0  1992/09/13  05:09:30  rosenkra
.\" total rewrite. this is first rev.
.\" 
.TH WHATIS 1
.SH NAME
whatis \- show description of word
.SH SYNOPSIS
.B whatis
[
.B \-l
] [
.B \-P
.I path
] [
.B \-s
.I section
]
.IR word ...
.SH DESCRIPTION
The
.B whatis
command displays a one line synopsis of each online
documentation file whose name matches the specified
.IR word .
To read the actual online documentation, use the
.IR man (1)
command.
.PP
.I Word
is considered separately from each other word.
The case of letters is significant.
.SH OPTIONS
The following switch options are recognized:
.IP \fB\-l\fR
a more verbose (long) output is given containing the one line
description plus a list of keywords, cross references, and the
primary manual page, if any.
.IP "\fB\-P \fIpath\fR"
if a valid
.I path
is given,
.B whatis
searches for the databases there (see ENVIRONMENT).
.IP "\fB\-s \fIsection\fR"
search only for items from the specified
.IR section .
This should be a single character representing a section of the
manual, i.e., from the list:
.nf

	0123456789lno
.fi
.SH ENVIRONMENT
.B Whatis
searches for the database file in the directory contained in the
.B MANPATH
environment variable.
Note that the
.B \-P
option overrides this.
If neither
.B MANPATH
or
.B \-P
are specified, a default path of ``d:/usr/man'' is used.
.SH FILES
.nf
MANPATH/whatis._?_	online documentation database file
.fi
.SH "SEE ALSO"
apropos(1), man(1), whatisin(1), whereis(1)
.SH AUTHOR
Bill Rosenkranz
.br
rosenkra@convex.com
.SH VERSION
whatis v2.0.1 92/9/12 rosenkra
