.\" $Id: whatisin.man,v 2.0 1992/09/13 05:09:30 rosenkra Exp $
.\"
.\" $Log: whatisin.man,v $
.\" Revision 2.0  1992/09/13  05:09:30  rosenkra
.\" total rewrite. this is first rev.
.\" 
.TH WHATISIN 1
.SH NAME
whatisin \- show contents of online documentation section
.SH SYNOPSIS
.B whatisin
[
.B \-P
.I path
] [
.I section
]
.SH DESCRIPTION
The
.B whatisin
command displays a one line synopsis of each file in a specified
online documentation section.
To read the actual online documentation, use the
.IR man (1)
command.
.PP
The argument
.I section
specifies a \*(lqsection\*(rq similar to those in the 4.2 BSD UNIX
Programmer's Manual (as explained below).
In this case, the description of that section is printed along with
a full list of all documentation in that section.
.PP
If no section is specified,
.B whatisin
displays a list of sections.
.SH OPTIONS
The following switch options are recognized:
.IP "\fB\-P \fIpath\fR"
if a valid
.I path
is given,
.B whatisin
searches for the databases there (see ENVIRONMENT).
.SH "SECTION NAMES"
The sections of the manual are based on the Unix Programmer's Manual:
.sp
.nf
Sect	UNIX Manual	Description
----	-----------	-----------
0	General		overview of features and documentation
1	Commands	commands (like those in \bin)
2	System calls	low-level library calls (C)
3	Subroutines	standard user calls (C)
4	Special files	things like emacs .CMD files
5	File formats	things like arc file formats
6	Games		games manual
7	Miscellaneous	miscellaneous information
8	Maintenance	system administration commands
.fi
.sp
In addition,
.B whatisin
recognizes the following section names:
.sp
.nf
l	local		files specific to local system
n	new		files added since current software release
o	old		files from previous software release
.fi
.SH ENVIRONMENT
.B Whatisin
searches for the database file in the directory contained in the
.B MANPATH
environment variable.
Note that the
.B \-P
option overrides this.
If neither
.B MANPATH
or
.B \-P
are specified, a default path of ``d:/usr/man'' is used.
.SH FILES
.nf
MANPATH/whatisin.___	manual section list (contents)
MANPATH/whatis._?_	online documentation database files
.fi
.SH "SEE ALSO"
apropos(1), man(1), whatis(1), whereis(1)
.SH AUTHOR
Bill Rosenkranz
.br
rosenkra@convex.com
.SH VERSION
whatisin 2.0.1 92/9/12 rosenkra
